/*
 *		RStars.h
 */

#include <add-ons/screen_saver/ScreenSaver.h>
#include <interface/StringView.h>
#include <BeBuild.h>

extern "C" {
	_EXPORT
	BScreenSaver *instantiate_screen_saver(BMessage *pMsg, image_id id);
}


// Constants
const rgb_color	COLOR_BLACK = {0, 0, 0, 0};

const float		DISTANCE = 500.0;
const float		STAR_SPEED = 10.0;
const uint32	NUM_STARS = 300;


// Class definition.
class RStars : public BScreenSaver
{
public:
				RStars(BMessage *pMsg, image_id id);
	virtual		~RStars(void);

	virtual void	StartConfig(BView *pView);
virtual status_t	StartSaver(BView *pView, bool bPreview );
	virtual void	Draw(BView *pView, int32 frame);

private:
	void	Project3Dto2D(void);
	void	Clear2DLines(BView *pView);
	void	Draw2DLines(BView *pView);

	float	m_height;
	float	m_width;
	bool	m_bInitScreenSaver;
	BRect	m_rc;

	float	m_X[NUM_STARS];
	float	m_Y[NUM_STARS];
	float	m_Z[NUM_STARS];

	BPoint	m_2D[NUM_STARS];
	rgb_color	m_Color[NUM_STARS];
};
